//+------------------------------------------------------------------+
//|                                                          cfb.mq4 |
//|                                                           mladen |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      "mladenfx@gmail.com"

#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1  Red

//
//
//
//
//

extern int    Depth = 30;
extern int    Price = PRICE_CLOSE;

//
//
//
//
//

double buffer1[];
double stored[][5];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   SetIndexBuffer(0,buffer1); SetIndexDrawBegin(0,Depth);
   return(0);
}
int deinit()
{
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int i,r,limit;
   
   if(counted_bars < 0) return(-1);
   if(counted_bars > 0) counted_bars--;
           limit = Bars-counted_bars;
           if (ArrayRange(stored,0) != Bars) ArrayResize(stored,Bars);

   //
   //
   //
   //
   //

   for(i=limit, r=Bars-i-1; i>=0; i--, r++)
   {
      buffer1[i] = calculateCFB(i,r,Depth);
   }
   return(0);
}


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

#define _prices 0
#define _roc    1
#define _value1 2
#define _value2 3
#define _value3 4

//
//
//
//
//

double calculateCFB(int i, int r, int depth)
{
   stored[r][_prices] = iMA(NULL,0,1,0,MODE_SMA,Price,i);

   //
   //
   //
   //
   //

      stored[r][_roc]    = MathAbs(stored[r][_prices] - stored[r-1][_prices]);
      stored[r][_value1] = stored[r-1][_value1] - stored[r-depth][_roc] + stored[r][_roc];
      stored[r][_value2] = stored[r-1][_value2] - stored[r-1][_value1] + stored[r][_roc]*depth;
      stored[r][_value3] = stored[r-1][_value3] - stored[r-1-depth][_prices] + stored[r-1][_prices];
   
      double dividend = MathAbs(depth*stored[r][_prices]-stored[r][_value3]);

      //
      //
      //
      //
      //
         
   if (stored[r][_value2] != 0)
         return( dividend / stored[r][_value2]);
   else  return(0.00);            
}